
(* This file was auto-generated based on "parserMessages.messages". *)

(* Please note that the function [message] can raise [Not_found]. *)

let message =
  fun s ->
    match s with
    | 11 ->
        "Ill-formed list of actual parameters.\nA modifier, a closing parenthesis, or a comma is expected at this point.\nA modifier is * or + or ?.\nExamples of well-formed actual parameters:\n  expr\n  expr+\n  option(expr)\n  separated_list(COMMA, expr)\n"
    | 10 | 101 ->
        "Ill-formed list of actual parameters.\nA comma-delimited list of actual parameters is expected at this point.\nExamples of well-formed actual parameters:\n  expr\n  expr+\n  option(expr)\n  separated_list(COMMA, expr)\n"
    | 149 ->
        "Either another rule\nor another production | ...\nis expected at this point.\nExamples of well-formed rules:\n  option(X): { None } | x = X { Some x }\n"
    | 88 ->
        "Ill-formed rule.\nA colon is expected at this point.\nExamples of well-formed rules:\n  option(X): { None } | x = X { Some x }\n"
    | 114 ->
        "Ill-formed rule.\nEither a semantic action { ... }\nor another production | ...\nis expected here.\nExamples of well-formed rules:\n  expr: MINUS e = expr %prec UMINUS { -e }\n"
    | 97 | 130 ->
        "Ill-formed rule.\nA comma-delimited list of actual parameters is expected at this point.\nExamples of well-formed rules:\n  call: f = callee LPAREN args = separated_list(COMMA, expr) RPAREN { f, args }\n  list(X): { [] } | x = X; xs = list(X) { x :: xs }\n"
    | 125 | 107 | 145 ->
        "Ill-formed %prec annotation.\nA symbol is expected at this point.\nExamples of well-formed annotations:\n  expr: MINUS e = expr %prec UMINUS { -e }\n"
    | 106 | 111 ->
        "Either another production | ...\nor a comma or a closing parenthesis\nis expected at this point.\n"
    | 100 | 136 | 137 | 99 | 112 ->
        "Ill-formed production.\nMaybe you meant to close a parenthesis at this point?\nA production is a sequence of producers, followed with a semantic action.\nExamples of well-formed producers:\n  expr\n  option(COMMA)\n  separated_list(COMMA, expr)\n  e = expr\n  ds = declaration*\n  es = list(terminated(expr, SEMI))\n  es = list(e = expr SEMI { e })\n  xs = list(x = var { Some x } | WILDCARD { None })\n"
    | 96 | 93 | 94 | 119 | 141 ->
        "Ill-formed production.\nA production is a sequence of producers, followed with a semantic action.\nExamples of well-formed producers:\n  expr\n  option(COMMA)\n  separated_list(COMMA, expr)\n  e = expr\n  ds = declaration*\n  es = list(terminated(expr, SEMI))\n  es = list(e = expr SEMI { e })\n  xs = list(x = var { Some x } | WILDCARD { None })\n"
    | 89 | 91 | 150 | 115 ->
        "Ill-formed rule.\nA list of productions is expected at this point.\nExamples of well-formed rules:\n  main: e = expr EOL { e }\n  expr: i = INT { i } | e1 = expr PLUS e2 = expr { e1 + e2 }\n  symbol: s = LID | s = UID { s }\n"
    | 80 | 83 | 84 ->
        "Ill-formed rule.\nA comma-delimited list of formal parameters is expected at this point.\nExamples of well-formed rules:\n  option(X): { None } | x = X { Some x }\n  pair(X, Y): x = X; y = Y { (x, y) }\n"
    | 79 ->
        "Ill-formed rule.\nEither a parenthesized, comma-delimited list of formal parameters\nor a colon is expected at this point.\nExamples of well-formed rules:\n  main: e = expr EOL { e }\n  expr: i = INT { i } | e1 = expr PLUS e2 = expr { e1 + e2 }\n  option(X): { None } | x = X { Some x }\n"
    | 70 | 72 | 76 ->
        "Ill-formed rule.\n%inline, %public, or a non-terminal symbol is expected at this point.\nExamples of well-formed rules:\n  %public option(X): { None } | x = X { Some x }\n  %inline clist(X): xs = separated_nonempty_list(COMMA?, X) { xs }\n  %public %inline pair(X, Y): x = X; y = Y { (x, y) }\n"
    | 144 ->
        "Either another rule or %% is expected at this point.\n"
    | 69 ->
        "Either a rule or %% is expected at this point.\n"
    | 51 ->
        "Ill-formed %parameter declaration.\nExamples of well-formed declarations:\n  %parameter <X : sig type t end>\n"
    | 61 | 64 | 65 ->
        "Ill-formed precedence declaration.\nExamples of well-formed declarations:\n  %left PLUS\n  %left PLUS MINUS\n  %nonassoc unary_minus\n  %right CONCAT\n"
    | 41 | 43 | 44 | 46 ->
        "Ill-formed %start declaration.\nA start symbol must begin with a lowercase letter.\nExamples of well-formed declarations:\n  %start program\n  %start expression phrase\n  %start <int> date time\n"
    | 33 | 35 | 36 | 38 ->
        "Ill-formed %token declaration.\nExamples of well-formed declarations:\n  %token FOO\n  %token DOT SEMICOLON\n  %token <string> LID UID\n"
    | 1 | 2 | 5 | 6 | 29 | 9 | 15 | 24 | 53 ->
        "Ill-formed declaration.\nExamples of well-formed declarations:\n  %type <Syntax.expression> expression\n  %type <int> date time\n  %type <int option> option(date)\n  %on_error_reduce expression\n  %on_error_reduce date time\n  %on_error_reduce option(date)\n"
    | 157 ->
        "Either another declaration or %% is expected at this point.\n"
    | 0 ->
        "Either a declaration or %% is expected at this point.\n"
    | _ ->
        raise Not_found
